CREATE SEQUENCE SQ_PAIS INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_PAIS 
  BEFORE INSERT ON PAIS
  FOR EACH ROW
BEGIN
  SELECT SQ_PAIS.NEXTVAL INTO :NEW.Id_Pais
  FROM DUAL;
END TR_PAIS; 
/
CREATE SEQUENCE SQ_ESTADO INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_ESTADO 
  BEFORE INSERT ON ESTADO
  FOR EACH ROW
BEGIN
  SELECT SQ_ESTADO.NEXTVAL INTO :NEW.Id_Estado
  FROM DUAL;
END TR_ESTADO; 
/

CREATE SEQUENCE SQ_REGION INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_REGION 
  BEFORE INSERT ON REGION
  FOR EACH ROW
BEGIN
  SELECT SQ_REGION.NEXTVAL INTO :NEW.Id_Region
  FROM DUAL;
END TR_REGION; 
/

CREATE SEQUENCE SQ_PARTIDO INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_PARTIDO 
  BEFORE INSERT ON PARTIDO
  FOR EACH ROW
BEGIN
  SELECT SQ_PARTIDO.NEXTVAL INTO :NEW.Id_Partido
  FROM DUAL;
END TR_PARTIDO; 
/

CREATE SEQUENCE SQ_ESTADO_GASTO INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_ESTADO_GASTO 
  BEFORE INSERT ON ESTADO_GASTO
  FOR EACH ROW
BEGIN
  SELECT SQ_ESTADO_GASTO.NEXTVAL INTO :NEW.Id_Estado_Gasto
  FROM DUAL;
END TR_ESTADO_GASTO; 
/

CREATE SEQUENCE SQ_CATEGORIA_GASTO INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_CATEGORIA_GASTO 
  BEFORE INSERT ON CATEGORIA_GASTO
  FOR EACH ROW
BEGIN
  SELECT SQ_CATEGORIA_GASTO.NEXTVAL INTO :NEW.Id_Categoria
  FROM DUAL;
END TR_CATEGORIA_GASTO; 
/

CREATE SEQUENCE SQ_FORMA_PAGO INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_FORMA_PAGO 
  BEFORE INSERT ON FORMA_PAGO
  FOR EACH ROW
BEGIN
  SELECT SQ_FORMA_PAGO.NEXTVAL INTO :NEW.Id_Pago
  FROM DUAL;
END TR_FORMA_PAGO; 
/

CREATE SEQUENCE SQ_CAMARA INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_CAMARA 
  BEFORE INSERT ON CAMARA
  FOR EACH ROW
BEGIN
  SELECT SQ_CAMARA.NEXTVAL INTO :NEW.Id_Camara
  FROM DUAL;
END TR_CAMARA; 
/

CREATE SEQUENCE SQ_PARLAMENTARIO_CAMARA INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_PARLAMENTARIO_CAMARA 
  BEFORE INSERT ON PARLAMENTARIO_CAMARA
  FOR EACH ROW
BEGIN
  SELECT SQ_PARLAMENTARIO_CAMARA.NEXTVAL INTO :NEW.Id_PARLAMENTARIO
  FROM DUAL;
END TR_PARLAMENTARIO_CAMARA; 
/

CREATE SEQUENCE SQ_GASTO INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_GASTO 
  BEFORE INSERT ON GASTO
  FOR EACH ROW
BEGIN
  SELECT SQ_GASTO.NEXTVAL INTO :NEW.Id_Gasto
  FROM DUAL;
END TR_GASTO; 
/

CREATE SEQUENCE SQ_LOG INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_LOG 
  BEFORE INSERT ON LOG
  FOR EACH ROW
BEGIN
  SELECT SQ_LOG.NEXTVAL INTO :NEW.Id_Log
  FROM DUAL;
END TR_LOG; 
/

CREATE SEQUENCE SQ_PARTIDO INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER TR_PARTIDO 
  BEFORE INSERT ON PARTIDO
  FOR EACH ROW
BEGIN
  SELECT SQ_PARTIDO.NEXTVAL INTO :NEW.Id_Partido
  FROM DUAL;
END TR_PARTIDO; 
/
