SET PAGESIZE 0 LINESIZE 2000 TRIMSPOOL ON FEEDBACK OFF ECHO OFF TERMOUT OFF;
SET SERVEROUTPUT ON;
spool pruebas.log
SET ECHO ON

DECLARE
   RSP VARCHAR2(500);
BEGIN
   
   -----------------------------------------------------
   -----    PROCEDIMIENTOS ABM                     -----
   -----------------------------------------------------
   
   --ALTA CORRECTA DE UNA NUEVA CAMARA PARLAMENTARIA
   SP_ALTA_CAMARA('Cmara 1',1,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA CORRECTA DE UNA NUEVA CAMARA PARLAMENTARIA
   SP_ALTA_CAMARA('Cmara 2',2,null,null,'C/ Calle 2',22222222,'www.web_camara2.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CAMARA PARLAMENTARIA YA EXISTENTE
   SP_ALTA_CAMARA('Cmara 1',1,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CAMARA PARLAMENTARIA CON ALGN DATO OBLIGATORIO A NULO
   SP_ALTA_CAMARA(null,1,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CAMARA PARLAMENTARIA QUE NO CUMPLE INTEGRIDAD CON EL PAIS
   SP_ALTA_CAMARA('Cmara 3',10,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN PARLAMENTARIO
   SP_ALTA_PARLAM('11111111A','Parlamentario 1',1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN PARLAMENTARIO YA DADO DE ALTA
   SP_ALTA_PARLAM('11111111A','Parlamentario 1',1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN PARLAMENTARIO CON EL CAMPO NOMBRE NULO
   SP_ALTA_PARLAM('11111111B',NULL,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA DE UN PARLAMENTARIO CON UN PARTIDO QUE NO EXISTE
   SP_ALTA_PARLAM('11111111B','Parlamentario 2',10,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN PARLAMENTARIO
   SP_ALTA_PARLAM('22222222B','Parlamentario 2',3,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN PARLAMENTARIO
   SP_ALTA_PARLAM('33333333C','Parlamentario 3',2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA PARLAMENTARIO QUE NO EXISTE EN CMARA 
   SP_ALTA_P_CAM('11111111B',1,'10/05/2010', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA PARLAMENTARIO EN UNA CMARA QUE NO EXISTE
   SP_ALTA_P_CAM('11111111A',4,'10/05/2010', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA PARLAMENTARIO EN UNA CMARA SIN INDICAR FECHA DE ALTA
   SP_ALTA_P_CAM('11111111A',1,null, null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA PARLAMENTARIO EN UNA CMARA CON FECHA DE ALTA MAYOR QUE LA DE BAJA
   SP_ALTA_P_CAM('11111111A',1,'10/04/2010', '10/04/2009', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN PARLAMENTARIO EN UNA CAMARA CON LA FECHA DE BAJA A NULO
   SP_ALTA_P_CAM('11111111A',1,'10/05/2010', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN PARLAMENTARIO EN UNA CAMARA CON LA FECHA DE BAJA A NULO
   SP_ALTA_P_CAM('22222222B',2,'10/04/2010', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN PARLAMENTARIO EN UNA CMARA CON SOLAPAMIENTO DE FECHAS
   SP_ALTA_P_CAM('11111111A',2,'10/05/2012', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA CORRECTA DE UN PARLAMENTARIO EN UNA CMARA
   SP_ALTA_P_CAM('11111111A',2,'01/05/2009', '01/05/2010', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN PARLAMENTARIO EN UNA CMARA
   SP_ALTA_P_CAM('33333333C',1,'01/05/2009', '09/09/2010', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN GASTO DE TIPO PARLAMENTARIO
   SP_ALTA_GASTO (2,NULL,'01/03/2010',101.15,10,NULL,1,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA DE UN GASTO DE UNA FECHA POSTERIOR A LA ACTUAL
   SP_ALTA_GASTO (2,NULL,'01/03/2014',101.15,10,NULL,1,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN GASTO INDICANDO EL PARLAMENTARIO Y LA CMARA
   SP_ALTA_GASTO (2,1,'01/01/2010',101.15,10,NULL,1,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN GASTO SIN INDICAR EL PARLAMENTARIO Y LA CMARA
   SP_ALTA_GASTO (NULL,NULL,'01/01/2010',101.15,10,NULL,1,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
      
   --ALTA DE UN GASTO DE UN PARLAMENTARIO QUE NO EXISTE
   SP_ALTA_GASTO (25,NULL,'01/01/2010',101.15,10,NULL,1,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN GASTO INDICANDO EL PARLAMENTARIO Y UN TIPO DE GASTO DE UNA CAMARA
   SP_ALTA_GASTO (2,NULL,'01/01/2010',101.15,10,NULL,10,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN GASTO INDICANDO LA CAMARA Y UN TIPO DE GASTO DE PARLAMENTARIO
   SP_ALTA_GASTO (NULL,1,'01/01/2010',101.15,10,NULL,1,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN GASTO DE UNA CAMARA
   SP_ALTA_GASTO (NULL,1,'01/01/2010',1115.25,10,NULL,10,'Desc 2','Just 2','http://gasto2',2,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --MODIFICACIN DE UN GASTO INEXISTENTE
   SP_MOD_GASTO(10,101.15,10,NULL,10,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --MODIFICACIN CORRECTA DE UN GASTO DE UN PARLAMENTARIO
   SP_MOD_GASTO(1,1011.5,10,NULL,1,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --MODIFICACIN CORRECTA DE UN GASTO DE UN PARLAMENTARIO
   SP_MOD_GASTO(2,1211.5,10,NULL,10,'Desc 2','Just 2','http://gasto2',2,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --MODIFICACIN DE UN GASTO DE PARLAMENTARIO CON UNA CATEGORA DE UNA CMARA
   SP_MOD_GASTO(1,1011.5,10,NULL,10,'Desc 1','Just 1','http://gasto1',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
    --MODIFICACIN DE UN PARLAMENTARIO EN CAMARA SIN INFORMAR EL PARLAMENTARIO 
    SP_MOD_P_CAM(NULL,'01/01/2011',NULL,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --MODIFICACIN DE UN PARLAMENTARIO EN CAMARA SIN INFORMAR LA FECHA DE ALTA 
    SP_MOD_P_CAM(1,NULL,NULL,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --MODIFICACIN DE UN PARLAMENTARIO CON SOLAPAMIENTO DE FECHAS 
    SP_MOD_P_CAM(1,'06/05/2009','04/01/2014',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    
    --MODIFICACIN DE UN PARLAMENTARIO CON SOLAPAMIENTO DE FECHAS POR GASTOS ASOCIADOS  
    SP_MOD_P_CAM(2,'05/05/2010','04/01/2014',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    
    --MODIFICACIN CORRECTA DE UN PARLAMENTARIO CON GASTOS ASOCIADOS 
    SP_MOD_P_CAM(2,'01/03/2010','04/01/2014',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    
    --MODIFICACIN DE UN PARLAMENTARIO SIN GASTOS ASOCIADOS CON SOLAPAMIENTO DE FECHAS 
    SP_MOD_P_CAM(3,'05/05/2010','04/01/2014',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
   
    --MODIFICACIN CORRECTA DE UN PARLAMENTARIO SIN GASTOS ASOCIADOS
    SP_MOD_P_CAM(3,'05/05/2010','04/10/2010',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --MODIFICACIN DE UN PARLAMENTARIO CON EL NIF NULO
    SP_MOD_PARLAM(NULL,'NOMBRE 1',2,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    
    --MODIFICACIN DE UN PARLAMENTARIO CON EL NOMBRE NULO
    SP_MOD_PARLAM('11111111A',NULL,2,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    
    --MODIFICACIN DE UN PARLAMENTARIO CON EL PARTIDO NULO
    SP_MOD_PARLAM('11111111A','NOMBRE 1',NULL,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    
    --MODIFICACIN DE UN PARLAMENTARIO CON PARTIDO INEXISTENTE
    SP_MOD_PARLAM('11111111A','NOMBRE 1',15,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --MODIFICACIN DE UN PARLAMENTARIO INEXISTENTE
    SP_MOD_PARLAM(10,'NOMBRE 1',2,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --MODIFICACIN CORRECTA DE UN PARLAMENTARIO
    SP_MOD_PARLAM('11111111A','NOMBRE 1',2,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

   --MODIFICACIN CAMARA PARLAMENTARIA NO EXISTENTE
   SP_MOD_CAMARA(10,'Cmara 1',1,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --MODIFICACIN CAMARA PARLAMENTARIA CON EL NOMBRE A NULO
   SP_MOD_CAMARA(1,null,null,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --MODIFICACIN CAMARA PARLAMENTARIA QUE NO CUMPLE INTEGRIDAD CON EL PAIS
   SP_MOD_CAMARA(2,'Cmara 2',10,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --MODIFICACIN CAMARA PARLAMENTARIA QUE CON NOMBRE DE OTRA YA EXISTENTE
   SP_MOD_CAMARA(1,'Cmara 2',2,null,null,'C/ Calle 1',99999999,'www.web_camara1.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --MODIFICACIN CAMARA PARLAMENTARIA QUE CON NOMBRE DE OTRA YA EXISTENTE
   SP_MOD_CAMARA(1,'Cmara A',2,null,null,'C/ Calle A',99999999,'www.web_camaraA.com',RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA DE UN PARLAMENTARIO EN CAMARA CON EL ID NULO
    SP_BAJA_P_CAM(NULL,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA DE UN PARLAMENTARIO NO EXISTENTE
    SP_BAJA_P_CAM(15,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA DE UN PARLAMENTARIO EN CAMARA CON GASTOS
    SP_BAJA_P_CAM(2,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA CORRECTA DE UN PARLAMENTARIO EN CAMARA
    SP_BAJA_P_CAM(1,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA CORRECTA DE UN PARLAMENTARIO EN CAMARA
    SP_BAJA_P_CAM(4,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);
    
    --BAJA DE UN PARLAMENTARIO CON NIF NULO
    SP_BAJA_PARLAM(NULL,RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA DE UN PARLAMENTARIO NO EXISTENTE
    SP_BAJA_PARLAM('11111111J',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA DE UN PARLAMENTARIO QUE EST O HA ESTADO DADO DE ALTA EN ALGUNA CAMARA
    SP_BAJA_PARLAM('11111111A',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

    --BAJA CORRECTA DE UN PARLAMENTARIO EN CAMARA
    SP_BAJA_PARLAM('33333333C',RSP);
    DBMS_OUTPUT.PUT_LINE(RSP);

     --BAJA CAMARA CON EL ID NULO
     SP_BAJA_CAMARA(NULL,RSP);
     DBMS_OUTPUT.PUT_LINE(RSP);

     --BAJA CAMARA NO EXISTENTE
     SP_BAJA_CAMARA(20,RSP);
     DBMS_OUTPUT.PUT_LINE(RSP);

     --BAJA CAMARA CON PARLAMENTARIOS
     SP_BAJA_CAMARA(2,RSP);
     DBMS_OUTPUT.PUT_LINE(RSP);

     --BAJA CAMARA CON GASTOS ASOCIADOS
     SP_BAJA_CAMARA(1,RSP);
     DBMS_OUTPUT.PUT_LINE(RSP);
      
     --ALTA CORRECTA DE UNA NUEVA CAMARA PARLAMENTARIA
     SP_ALTA_CAMARA('Cmara 3',3,null,null,'C/ Calle 3',99999999,'www.web_camara3.com',RSP);
     DBMS_OUTPUT.PUT_LINE(RSP);

     --BAJA CAMARA CON GASTOS ASOCIADOS
     SP_BAJA_CAMARA(3,RSP);
     DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
DECLARE
   RSP VARCHAR2(500);
BEGIN
   
   -----------------------------------------------------
   -----         ESTADISTIICAS                     -----
   -----------------------------------------------------
   
   --ALTA CORRECTA DE UN PARLAMENTARIO
   SP_ALTA_PARLAM('33333333C','Parlamentario 3',1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA DE UN GASTO DE UNA CAMARA
   SP_ALTA_GASTO (NULL,1,'12/12/2009',11.25,10,NULL,12,'Desc 3','Just 3','http://gasto3',2,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   SP_ALTA_GASTO (NULL,1,'01/01/2010',30.05,11,NULL,12,'Desc 4','Just 4','http://gasto4',3,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   SP_ALTA_GASTO (NULL,1,'01/01/2011',25.25,12,NULL,12,'Desc 5','Just 5','http://gasto5',4,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   SP_ALTA_GASTO (NULL,1,'01/01/2012',40.25,13,NULL,12,'Desc 6','Just 6','http://gasto6',2,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   SP_ALTA_GASTO (NULL,1,'01/01/2013',7.25,14,NULL,12,'Desc 7','Just 7','http://gasto7',3,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   SP_ALTA_GASTO (NULL,1,'01/01/2014',110.85,15,NULL,12,'Desc 8','Just 8','http://gasto8',4,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   SP_ALTA_GASTO (NULL,2,'12/12/2009',111.25,10,NULL,12,'Desc 9','Just 9','http://gasto9',2,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   SP_ALTA_GASTO (NULL,2,'01/01/2010',130.05,11,NULL,12,'Desc 10','Just 10','http://gasto10',3,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN GASTO DE TIPO PARLAMENTARIO
   SP_ALTA_GASTO (2,NULL,'01/03/2010',101.15,10,NULL,1,'Desc 11','Just 11','http://gasto11',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN GASTO DE TIPO PARLAMENTARIO
   SP_ALTA_GASTO (3,NULL,'01/03/2010',1010.15,10,NULL,4,'Desc 12','Just 12','http://gasto12',1,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN GASTO DE TIPO PARLAMENTARIO
   SP_ALTA_GASTO (3,NULL,'01/03/2009',11.15,11,NULL,2,'Desc 13','Just 13','http://gasto13',3,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN GASTO DE TIPO PARLAMENTARIO
   SP_ALTA_GASTO (2,NULL,'01/05/2012',45.20,10,NULL,3,'Desc 14','Just 14','http://gasto14',4,1,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN GASTO DE TIPO PARLAMENTARIO
   SP_ALTA_GASTO (3,NULL,'01/06/2013',100.85,10,NULL,7,'Desc 15','Just 15','http://gasto15',3,2,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --ALTA CORRECTA DE UN PARLAMENTARIO
   SP_ALTA_P_CAM('33333333C',1,'01/01/2009',NULL,RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

END;

   -----------------------------------------------------
   -----         PRUEBAS CONSULTAS                 -----
   -----------------------------------------------------
/
SELECT * FROM TABLE(ConsultaA(2,2013,'11111111A'));
/
SELECT * FROM TABLE(ConsultaB(2,2010));
/
SELECT * FROM TABLE(ConsultaC(2010));
/
SELECT * FROM TABLE(ConsultaD(2010,2));
/
SELECT * FROM TABLE(ConsultaE(2010,2));
/
SELECT * FROM TABLE(ConsultaF(2010));
/

SELECT * FROM TABLA_LOG
/
SPOOL OFF

EXIT